"""
    FactSet Overview Report Builder API

    Get relevant industry-specific data for high level analysis of public and private companies  # noqa: E501

    The version of the OpenAPI document: 1.1.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.OverviewReportBuilder.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.OverviewReportBuilder.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.OverviewReportBuilder.model.key_stats_attribute_meta_periodicity import KeyStatsAttributeMetaPeriodicity
    from fds.sdk.OverviewReportBuilder.model.key_stats_data_object_entity_employees_as_of_date import KeyStatsDataObjectEntityEmployeesAsOfDate
    from fds.sdk.OverviewReportBuilder.model.profile_data_item_active_firm import ProfileDataItemActiveFirm
    from fds.sdk.OverviewReportBuilder.model.profile_data_object_size_ev import ProfileDataObjectSizeEv
    from fds.sdk.OverviewReportBuilder.model.profile_data_object_stage_crunchbase_rank import ProfileDataObjectStageCrunchbaseRank
    from fds.sdk.OverviewReportBuilder.model.profile_data_object_stage_pevc_latest_post_money_valuation import ProfileDataObjectStagePevcLatestPostMoneyValuation
    from fds.sdk.OverviewReportBuilder.model.profile_data_object_stage_trade_date_range import ProfileDataObjectStageTradeDateRange
    globals()['KeyStatsAttributeMetaPeriodicity'] = KeyStatsAttributeMetaPeriodicity
    globals()['KeyStatsDataObjectEntityEmployeesAsOfDate'] = KeyStatsDataObjectEntityEmployeesAsOfDate
    globals()['ProfileDataItemActiveFirm'] = ProfileDataItemActiveFirm
    globals()['ProfileDataObjectSizeEv'] = ProfileDataObjectSizeEv
    globals()['ProfileDataObjectStageCrunchbaseRank'] = ProfileDataObjectStageCrunchbaseRank
    globals()['ProfileDataObjectStagePevcLatestPostMoneyValuation'] = ProfileDataObjectStagePevcLatestPostMoneyValuation
    globals()['ProfileDataObjectStageTradeDateRange'] = ProfileDataObjectStageTradeDateRange


class ProfileDataObjectStage(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'exchange_primary': (KeyStatsAttributeMetaPeriodicity,),  # noqa: E501
            'founded_year': (KeyStatsAttributeMetaPeriodicity,),  # noqa: E501
            'pevc_backing': (KeyStatsAttributeMetaPeriodicity,),  # noqa: E501
            'trade_date_range': (ProfileDataObjectStageTradeDateRange,),  # noqa: E501
            'crunchbase_rank': (ProfileDataObjectStageCrunchbaseRank,),  # noqa: E501
            'pe_active_acq_amt': (ProfileDataObjectSizeEv,),  # noqa: E501
            'pe_active_acq_date': (KeyStatsAttributeMetaPeriodicity,),  # noqa: E501
            'pe_active_firm_number': (KeyStatsDataObjectEntityEmployeesAsOfDate,),  # noqa: E501
            'pe_active_firms': ([ProfileDataItemActiveFirm],),  # noqa: E501
            'pe_active_investment_number': (KeyStatsDataObjectEntityEmployeesAsOfDate,),  # noqa: E501
            'pe_last_investment_date': (KeyStatsAttributeMetaPeriodicity,),  # noqa: E501
            'pevc_latest_post_money_valuation': (ProfileDataObjectStagePevcLatestPostMoneyValuation,),  # noqa: E501
            'vc_last_round': (KeyStatsAttributeMetaPeriodicity,),  # noqa: E501
            'vc_last_round_amt': (ProfileDataObjectSizeEv,),  # noqa: E501
            'vc_last_round_date': (KeyStatsAttributeMetaPeriodicity,),  # noqa: E501
            'vc_last_round_investor_number': (KeyStatsDataObjectEntityEmployeesAsOfDate,),  # noqa: E501
            'vc_total_est_raised': (ProfileDataObjectSizeEv,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'exchange_primary': 'exchangePrimary',  # noqa: E501
        'founded_year': 'foundedYear',  # noqa: E501
        'pevc_backing': 'pevcBacking',  # noqa: E501
        'trade_date_range': 'tradeDateRange',  # noqa: E501
        'crunchbase_rank': 'crunchbaseRank',  # noqa: E501
        'pe_active_acq_amt': 'peActiveAcqAmt',  # noqa: E501
        'pe_active_acq_date': 'peActiveAcqDate',  # noqa: E501
        'pe_active_firm_number': 'peActiveFirmNumber',  # noqa: E501
        'pe_active_firms': 'peActiveFirms',  # noqa: E501
        'pe_active_investment_number': 'peActiveInvestmentNumber',  # noqa: E501
        'pe_last_investment_date': 'peLastInvestmentDate',  # noqa: E501
        'pevc_latest_post_money_valuation': 'pevcLatestPostMoneyValuation',  # noqa: E501
        'vc_last_round': 'vcLastRound',  # noqa: E501
        'vc_last_round_amt': 'vcLastRoundAmt',  # noqa: E501
        'vc_last_round_date': 'vcLastRoundDate',  # noqa: E501
        'vc_last_round_investor_number': 'vcLastRoundInvestorNumber',  # noqa: E501
        'vc_total_est_raised': 'vcTotalEstRaised',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, exchange_primary, founded_year, pevc_backing, trade_date_range, *args, **kwargs):  # noqa: E501
        """ProfileDataObjectStage - a model defined in OpenAPI

        Args:
            exchange_primary (KeyStatsAttributeMetaPeriodicity):
            founded_year (KeyStatsAttributeMetaPeriodicity):
            pevc_backing (KeyStatsAttributeMetaPeriodicity):
            trade_date_range (ProfileDataObjectStageTradeDateRange):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            crunchbase_rank (ProfileDataObjectStageCrunchbaseRank): [optional]  # noqa: E501
            pe_active_acq_amt (ProfileDataObjectSizeEv): [optional]  # noqa: E501
            pe_active_acq_date (KeyStatsAttributeMetaPeriodicity): [optional]  # noqa: E501
            pe_active_firm_number (KeyStatsDataObjectEntityEmployeesAsOfDate): [optional]  # noqa: E501
            pe_active_firms ([ProfileDataItemActiveFirm]): [optional]  # noqa: E501
            pe_active_investment_number (KeyStatsDataObjectEntityEmployeesAsOfDate): [optional]  # noqa: E501
            pe_last_investment_date (KeyStatsAttributeMetaPeriodicity): [optional]  # noqa: E501
            pevc_latest_post_money_valuation (ProfileDataObjectStagePevcLatestPostMoneyValuation): [optional]  # noqa: E501
            vc_last_round (KeyStatsAttributeMetaPeriodicity): [optional]  # noqa: E501
            vc_last_round_amt (ProfileDataObjectSizeEv): [optional]  # noqa: E501
            vc_last_round_date (KeyStatsAttributeMetaPeriodicity): [optional]  # noqa: E501
            vc_last_round_investor_number (KeyStatsDataObjectEntityEmployeesAsOfDate): [optional]  # noqa: E501
            vc_total_est_raised (ProfileDataObjectSizeEv): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.exchange_primary = exchange_primary
        self.founded_year = founded_year
        self.pevc_backing = pevc_backing
        self.trade_date_range = trade_date_range
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, exchange_primary, founded_year, pevc_backing, trade_date_range, *args, **kwargs):  # noqa: E501
        """ProfileDataObjectStage - a model defined in OpenAPI

        Args:
            exchange_primary (KeyStatsAttributeMetaPeriodicity):
            founded_year (KeyStatsAttributeMetaPeriodicity):
            pevc_backing (KeyStatsAttributeMetaPeriodicity):
            trade_date_range (ProfileDataObjectStageTradeDateRange):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            crunchbase_rank (ProfileDataObjectStageCrunchbaseRank): [optional]  # noqa: E501
            pe_active_acq_amt (ProfileDataObjectSizeEv): [optional]  # noqa: E501
            pe_active_acq_date (KeyStatsAttributeMetaPeriodicity): [optional]  # noqa: E501
            pe_active_firm_number (KeyStatsDataObjectEntityEmployeesAsOfDate): [optional]  # noqa: E501
            pe_active_firms ([ProfileDataItemActiveFirm]): [optional]  # noqa: E501
            pe_active_investment_number (KeyStatsDataObjectEntityEmployeesAsOfDate): [optional]  # noqa: E501
            pe_last_investment_date (KeyStatsAttributeMetaPeriodicity): [optional]  # noqa: E501
            pevc_latest_post_money_valuation (ProfileDataObjectStagePevcLatestPostMoneyValuation): [optional]  # noqa: E501
            vc_last_round (KeyStatsAttributeMetaPeriodicity): [optional]  # noqa: E501
            vc_last_round_amt (ProfileDataObjectSizeEv): [optional]  # noqa: E501
            vc_last_round_date (KeyStatsAttributeMetaPeriodicity): [optional]  # noqa: E501
            vc_last_round_investor_number (KeyStatsDataObjectEntityEmployeesAsOfDate): [optional]  # noqa: E501
            vc_total_est_raised (ProfileDataObjectSizeEv): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.exchange_primary = exchange_primary
        self.founded_year = founded_year
        self.pevc_backing = pevc_backing
        self.trade_date_range = trade_date_range
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
